/*
 * Copyright (c) 2013 CNRS/LAAS
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _RMP440_IO_H
#define _RMP440_IO_H

#define RMP440_CMD_BUF_SIZE 12

struct rmp440_io {
	int fd;
	enum RMP440_INTERFACE_TYPE interface;
	ssize_t (*send)(const struct rmp440_io *, const uint8_t *);
	ssize_t (*receive)(const struct rmp440_io *, uint8_t *, size_t);
	void (*close)(const struct rmp440_io *);
};


extern struct rmp440_io *rmpUsbInit(const char *);
extern struct rmp440_io *rmpInetInit(const char *);

extern ssize_t rmp440Send(const struct rmp440_io *, const uint8_t *);
extern ssize_t rmp440Receive(const struct rmp440_io *, uint8_t *, size_t);

extern int rmp440SendMsgInt(const struct rmp440_io *,
    uint16_t, uint32_t, uint32_t);
extern int rmp440SendMsgIntFloat(const struct rmp440_io *,
    uint16_t, uint32_t, double);
extern int rmp440SendMsgFloat(const struct rmp440_io *,
    uint16_t, double, double);

#endif
